﻿<?xml version='1.0' encoding='UTF-8'?>
<xsl:stylesheet
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:msdndomain="http://msdn.microsoft.com/aboutmsdn/rss/domains"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:user="foo"
	version="1.0"
>

	<xsl:include href="bds:/xsl/languageStrings.xsl" />

	<msxsl:script implements-prefix="user" language="JScript">
		<![CDATA[
			function replaceBackslash(path) {
				return path.replace(/\\/gi, '\\\\');
			}
		]]>
	</msxsl:script>
	<xsl:template match='*'>
		<xsl:apply-templates select='channel' />
	</xsl:template>

	<xsl:template match='channel'>
		<div class="menuBar">
			<div class="menuHeader">
				<span class="menuHeaderText"><xsl:value-of select="title" /></span>
				<xsl:if test="count(reload) &gt; 0">
					<a href="{reload}"><img src="./Images/ButtonReload.gif" class="menuHeaderReload" width="17" height="17" alt="{$reloadList}" /></a>
				</xsl:if>
			</div>
			<xsl:if test="count(file) &gt; 0">
				<ul class="menuBarSelection"><xsl:apply-templates select="file" /></ul>
			</xsl:if>
			<ul class="menuBarAction">
				<xsl:if test="count(file) &gt; 0">
					<xsl:if test="count(item) &gt; 0">
						<xsl:apply-templates select="item" />
					</xsl:if>
				</xsl:if>
				<xsl:if test="count(action) &gt; 0">
					<xsl:apply-templates select="action" />
				</xsl:if>
			</ul>
		</div>
	</xsl:template>

	<xsl:template match='item'>
		<li><a href="{link}" title="{fullTitle}"><xsl:value-of select="title" /></a></li>
	</xsl:template>

	<xsl:template match='file'>
		<li><a href="javascript:openFileLink('{user:replaceBackslash(normalize-space(file))}');" title="{fullTitle}"><xsl:value-of select="title" /></a></li>
	</xsl:template>

	<xsl:template match='action'>
		<li><a href="{link}" title="{fullTitle}"><xsl:value-of select="title" /></a></li>
	</xsl:template>

</xsl:stylesheet>