﻿<?xml version='1.0' encoding='UTF-8'?>
<xsl:stylesheet
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:msdndomain="http://msdn.microsoft.com/aboutmsdn/rss/domains"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:user="foo"
	version="1.0"
>

	<xsl:include href="bds:/xsl/languageStrings.xsl" />

	<msxsl:script implements-prefix="user" language="JScript">
		<![CDATA[
			function cropFolders(path) {
				var maxPathLen = 60;
				var pathThreshold = 20;

				var res;
				var endPath;
				var pathParts;
				var len;
				var lenHalf;
				var i;

				res = '';
				if (path.slice(0, 2) == '\\\\') {
					res = '\\\\';
					path = path.slice(2);
				}
				if (path.length > maxPathLen) {
					pathParts = path.split('\\');
					len = pathParts.length;
					lenHalf = len / 2;
					endPath = '';
					i = 0;
					while ((res.length + endPath.length < maxPathLen - pathThreshold) && (i - 1 < lenHalf)) {
						endPath = '\\' + pathParts[len - i - 1] + endPath;
						if (res.length + endPath.length < maxPathLen - pathThreshold) {
							res += pathParts[i] + '\\';
						}
						i++;
					}
					res += '...' + endPath;
				} else {
					res += path;
				}
				return res;
			}

			function replaceBackslash(path) {
				return path.replace(/\\/gi, '\\\\');
			}
		]]>
	</msxsl:script>

	<xsl:template match='/*'>
		<xsl:apply-templates select='channel/group'>
			<xsl:sort select="title" />
		</xsl:apply-templates>
		<div>
			<div>
				<h2 class="action">
					<xsl:value-of select="$createFavoriteGroup" />
				</h2>
			</div>
			<div>
				<xsl:value-of select="$groupTitle" />
				<input type="Text" value="" />
				&#160;
				<a onmousedown="CreateFavGroup(this);" class="contentAreaHeadlineSubLink">
					<xsl:value-of select="$create" />
				</a>
			</div>
		</div>
	</xsl:template>

	<xsl:template match='group'>
		<div>
			<div name="group">
				<div name="autoShow">
					<h2>
						<span>
							<xsl:value-of select="title" />
						</span>
						&#160;
						<a onmousedown="EditFavTitle(this);" class="contentAreaHeadlineSubLink">
							<xsl:value-of select="$edit" />
						</a>
						&#160;
						<a onmousedown="removeFavoriteGroup(this, '{title}')" class="contentAreaHeadlineSubLink">
							<xsl:value-of select="$delete" />
						</a>
					</h2>
				</div>
				<div NAME="autoHide" class="wuppdi">
					<h2>
						<input type="Text" value="{title}" class="editTitle" />
						<input type="Hidden" value="{title}" class="editTitle" />
						&#160;
						<a onmousedown="SetFavTitle(this, true);" class="contentAreaHeadlineSubLink">
							<xsl:value-of select="$save" />
						</a>
						&#160;
						<a onmousedown="SetFavTitle(this, false);" class="contentAreaHeadlineSubLink">
							<xsl:value-of select="$cancel" />
						</a>
					</h2>
				</div>
			</div>
			<xsl:apply-templates select='file'>
				<xsl:sort select="title" />
				<xsl:sort select="file" />
			</xsl:apply-templates>
		</div>
	</xsl:template>

	<xsl:template match='file'>
		<div class="contentAreaHeadline">
			<a onmousedown="moveFavoriteToShow(this);" class="contentAreaHeadlineSubLink">
				<xsl:value-of select="$move" />
			</a>
			<span name="autoHide" class="wuppdi">
				&#160;
				<a class="contentAreaHeadlineSubLink"><xsl:value-of select="$to" /></a>
				&#160;
				<select onchange="moveFavoriteTo(this, '{user:replaceBackslash(normalize-space(file))}')">
				</select>
			</span>
			&#160;
			<a onmousedown="unmakeProjectFavorite(this, '{user:replaceBackslash(normalize-space(file))}');" class="contentAreaHeadlineSubLink">
				<xsl:value-of select="$delete" />
			</a>
			&#160;
			<a title="{fullTitle}">
				<xsl:value-of select="title" />
			</a>
		</div>
	</xsl:template>
	
</xsl:stylesheet>
