﻿<?xml version='1.0' encoding='UTF-8'?>
<xsl:stylesheet
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:msdndomain="http://msdn.microsoft.com/aboutmsdn/rss/domains"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:user="foo"
	version="1.0"
>

	<xsl:output method="html"/>

	<xsl:include href="bds:/xsl/languageStrings.xsl" />

	<msxsl:script implements-prefix="user" language="JScript">
		<![CDATA[
			function removeSpecialTags(data)
			{
				data = data.replace(/(<\/p[\s]*>)|(<li[^>]*>)/gi, "<br \/>");
				data = data.replace(/(<(?!(br|a|code|pre|wpLine|\/))[^>]*>)/gi, "");
				data = data.replace(/(<\/(?!(a|code|pre|wpLine))[^>]*>)/gi, "");

				data = data.replace(/<br[^>]*>[\s]*<br[^>]*>/gi, "<br \/>");
				data = data.replace(/<br[^>]*>[\s]*<br[^>]*>/gi, "<br \/>");
				data = data.replace(/<br[^>]*>[\s]*<br[^>]*>/gi, "<br \/>");
				data = data.replace(/<br[^>]*>[\s]*<br[^>]*>/gi, "<br \/>");
				data = data.replace(/<br[^>]*>[\s]*<br[^>]*>/gi, "<br \/>");
				data = data.replace(/<wpLine>/gi, "<div class='wpLine' \/>");

				return data;
				// debug code, comment-out previous line to check up the results
				return data.replace(/&/gi, "&amp;").replace(/</gi, "&lt;").replace(/>/gi, "&gt;");
			}

			function removeSize(data)
			{
            	 return data.replace(/<(font)[^>]*>/gi,"").replace(/<(\/font)>/gi, "");
			}

			function checkTag(tag, res)
			{
				var idxO, idxC;
				
				idxO = res.indexOf('<' + tag);
				while (idxO >= 0)
				{
					idxC = res.indexOf(idxO, '</' + tag);
					if (idxC < 0)
					{
						res += '</' + tag + '> ';
					}
					idxO = res.indexOf(idxO + 1, '<' + tag);
				}
				return res;
			}

			function checkTags(res)
			{
				res = checkTag('a', res);
				res = checkTag('A', res);
				res = checkTag('code', res);
				res = checkTag('CODE', res);
				res = checkTag('pre', res);
				res = checkTag('PRE', res);
				
				return res;
			}
			function trimNextWord(text)
			{
				var idx;
				var nIdx;
				var start;
				var substr;

				substr = text.substr(50);
				idx = substr.indexOf('<');
				if (idx >= 0 && substr.charAt(idx + 1) == '/')
				{
					start = text.substr(0, 50 + idx);
					substr = text.substr(50 + idx);
					return checkTags(start + substr.substr(0, substr.indexOf('>') + 1));
				} else {
					start = text.substr(0, 50);
					idx = substr.indexOf('.') + 1;
					nIdx = substr.indexOf('<'); if (nIdx >= 0 && nIdx < idx) idx = nIdx;
					nIdx = substr.indexOf(')'); if (nIdx >= 0 && nIdx < idx) idx = nIdx;
					return checkTags(text.substr(0, 50 + idx));
				}
			}
		]]>
	</msxsl:script>

	<xsl:template match='xml'>
		<xsl:apply-templates select='rss[@selectOnly != "1"]'>
			<xsl:sort select="order" order="ascending" />
			<xsl:sort select="channel/title" order="ascending" />
		</xsl:apply-templates>
	</xsl:template>

	<xsl:template match='rss'>
		<span class="contentSummary">
			<xsl:apply-templates select='channel'>
			</xsl:apply-templates>
		</span>
	</xsl:template>

	<xsl:template match='channel'>
		<div class="contentSummaryHeadline">


			<xsl:variable name="Desc" select="user:removeSize(user:removeSpecialTags(normalize-space(title)))" />
			<xsl:variable name="Length" select="string-length($Desc)" />
			<xsl:choose>
				<xsl:when test="$Length &lt;= 50 or @ignoreSize = '1'">
					<xsl:choose>
						<xsl:when test="(link) != ''">
							<a href="{link}"><xsl:value-of select="$Desc" disable-output-escaping="yes" /></a>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$Desc" />
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="(link) != ''">
							<a href="{link}"><xsl:value-of select="user:trimNextWord($Desc)" disable-output-escaping="yes" /></a>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$Desc" />
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</div>
		<ul>
			<xsl:apply-templates select="item">
				<xsl:with-param name="IgnoreSize"><xsl:value-of select="@ignoreSize" /></xsl:with-param>
			</xsl:apply-templates>
		</ul>
	</xsl:template>

	<xsl:template match='item'>
		<xsl:param name="IgnoreSize" />
		<xsl:if test="position() &lt;= 5 or $IgnoreSize = 1">
			<li>
				<xsl:choose>
					<xsl:when test="(link) != ''">
						<a href="{link}" class="contentSummaryLink"><xsl:value-of select="title" /></a>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="title" />
					</xsl:otherwise>
				</xsl:choose>
			</li>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>